function varargout = PC1000(varargin)
% PC1000 M-file for PC1000.fig
%      PC1000, by itself, creates a new PC1000 or raises the existing
%      singleton*.
%
%      H = PC1000 returns the handle to a new PC1000 or the handle to
%      the existing singleton*.
%
%      PC1000('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in PC1000.M with the given input arguments.
%
%      PC1000('Property','Value',...) creates a new PC1000 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before PC1000_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to PC1000_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help PC1000

% Last Modified by GUIDE v2.5 19-Mar-2004 10:07:36

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @PC1000_OpeningFcn, ...
                   'gui_OutputFcn',  @PC1000_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before PC1000 is made visible.
function PC1000_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to PC1000 (see VARARGIN)

% Choose default command line output for PC1000
handles.output = hObject;


% UIWAIT makes PC1000 wait for user response (see UIRESUME)
% uiwait(handles.EC1XGpibfigure);

DisableGpibButtons(handles);
set (handles.GPIBAddPopMenu,'Value',6);
handles.ChartTempData = [];
handles.ElapsedTimeData = [];
guidata(hObject,handles);

% --- Outputs from this function are returned to the command line.
function varargout = PC1000_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in HeatEnableButton.
function HeatEnableButton_Callback(hObject, eventdata, handles)
% hObject    handle to HeatEnableButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of HeatEnableButton
% Get the current state of button and  send command to enable/disable heat and set the 
% background to yellow if enabled or gray if disabled
ButtonState = get(hObject,'Value'); 
if ButtonState
    fprintf(handles.SunGpibObject,'C1ON+');
    set(handles.HeatEnableButton,'backgroundcolor','yellow');
      
else
    fprintf(handles.SunGpibObject,'C1OFF+');
    set(handles.HeatEnableButton,'backgroundcolor','default');
end

    
% --- Executes on button press in PowerButton.
function PowerButton_Callback(hObject, eventdata, handles)
% hObject    handle to PowerButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of PowerButton


ButtonState = get(hObject,'Value');
% if button turned on execute following if block
if ButtonState
    % if an error occurred during execution of TurnOnController function then TurnOn value will
    % be zero.
    TurnOn = TurnOnController(handles);
    if ~TurnOn % error occurred, turn off button and exit callback
        set(hObject,'Value',0);
        return;
    else
        % if controller was turned on, disable GPIB address popup menu
        set(handles.GPIBAddPopMenu,'Enable','Off');
    end
   
    
else
    % if power button was turned off then turn of chart and display timers
    % if they are running and issue off command and disable figure buttons
    % and text boxes
    ChartRunning = get(handles.ChartTempTimer,'running');
    if ChartRunning
        stop(handles.ChartTempTimer)
    end
    DispTimerRunning = get(handles.DisplayTempTimer,'running');
    if DispTimerRunning
        stop(handles.DisplayTempTimer)
    end
    
    TurnOffController(handles);
    set(handles.GPIBAddPopMenu,'Enable','On');
end

% --- Executes on button press in CoolEnableButton.
function CoolEnableButton_Callback(hObject, eventdata, handles)
% hObject    handle to CoolEnableButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of CoolEnableButton
ButtonState = get(hObject,'Value');
if ButtonState
    fprintf(handles.SunGpibObject,'C1ON-');
    set(handles.CoolEnableButton,'backgroundcolor','yellow');
else
    fprintf(handles.SunGpibObject,'C1OFF-');
    set(handles.CoolEnableButton,'backgroundcolor','default');
end

% --- Executes during object creation, after setting all properties.
function SetEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to SetEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function SetEdit_Callback(hObject, eventdata, handles)
% hObject    handle to SetEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of SetEdit as text
%        str2double(get(hObject,'String')) returns contents of SetEdit as a double


% --- Executes during object creation, after setting all properties.
function WaitEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to WaitEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function WaitEdit_Callback(hObject, eventdata, handles)
% hObject    handle to WaitEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of WaitEdit as text
%        str2double(get(hObject,'String')) returns contents of WaitEdit as a double


% --- Executes during object creation, after setting all properties.
function RateEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to RateEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function RateEdit_Callback(hObject, eventdata, handles)
% hObject    handle to RateEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user 


% --- Executes on button press in StopButton.
function StopButton_Callback(hObject, eventdata, handles)
% hObject    handle to StopButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
fprintf(handles.SunGpibObject,'STOP');


% --- Executes on button press in SendButton.
function SendButton_Callback(hObject, eventdata, handles)
% hObject    handle to SendButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

strSetCommand = ['SET1='  get(handles.SetEdit,'string')];
strWaitCommand = ['WAIT1='  get(handles.WaitEdit,'string')];
strRateCommand = ['RATE1='  get(handles.RateEdit,'string')];
fprintf(handles.SunGpibObject,strRateCommand);    
fprintf(handles.SunGpibObject,strSetCommand);
fprintf(handles.SunGpibObject,strWaitCommand);

function TurnOn = TurnOnController (handles)
TurnOn = 1; % value of 1 indicates a successfull gpib connection
GPIBAddress = get(handles.GPIBAddPopMenu,'Value');
%attempt to create and open a gpib object, result depends on value of
%ConnectError of 0 = success while 1,2 or 3 indicates an error
ConnectError = ConnectToGpib(GPIBAddress); 
% execute if block if a non-zeror value (error condition)
if ConnectError
    TurnOn = 0;
    switch ConnectError
        case 1
            ErrorMessage = char('No GPIB drivers found...Must have instrument control toolbox installed',...
                                lasterr);
            ErrorTitle = 'GPIB Error';         
        case 2
            ErrorMessage = char('Unable to create GPIB object',lasterr);
            ErrorTitle = 'GPIB Error'; 
        case 3
            ErrorMessage = char(lasterr,'Unable to connect to GPIB instrument',' ',...
                'Verify the following: ',...
                'GPIB address selected matches GPIB address of controller',...
                'Verify both ends of GPIB cable are securely connected',...
                'Verify power to the chamber');
            ErrorTitle = 'Error using fopen(GPIBObject)';
    end
    %display the error dialog box with one of the messages above
    errordlg(ErrorMessage,ErrorTitle);

    return; % leave function since error occurred
end

% a successfull gpib connection will execute following code
SunGpibObject = instrfind('primaryaddress',GPIBAddress);
% store gpib object variable for the controller into the handles structure for
% later use
handles.SunGpibObject = SunGpibObject;  
% get any timers with the following properties if available, if not create
% a display timer to display temperature with a period of 5 seconds and a
% chart timer with an initial period of one minute
DisplayTempTimer = timerfind('executionmode','fixedrate','period',5);
if isempty(DisplayTempTimer)
    DisplayTempTimer = timer('executionmode','fixedrate');
    set(DisplayTempTimer,'timerfcn',{'GuiDisplayTimerFunction_PC1000',GPIBAddress,handles},'period',5);
end
ChartTempTimer = timerfind('executionmode','fixedrate','period',60);
if isempty(ChartTempTimer)
    ChartTempTimer = timer('executionmode','fixedrate');
    set(ChartTempTimer,'timerfcn',{'GuiChartTimerFunction_PC1000',GPIBAddress,handles},'period',60);
    set(ChartTempTimer,'startfcn',{'GuiChartTimerStart_PC1000',GPIBAddress,handles});
end
% store timer objects in the handles structure 
handles.ChartTempTimer = ChartTempTimer;
handles.DisplayTempTimer = DisplayTempTimer;
% Update handles structure
guidata(handles.EC1XGpibFigure, handles);
%issue command to turn on controller and enable appropriate buttons on the
%figure
fprintf (handles.SunGpibObject,'ON');
EnableGPIBButtons(handles);
%start the display timer to get and display controller temperatures
start (handles.DisplayTempTimer);

% --- Executes when user attempts to close EC1XGpibFigure.
function EC1XGpibFigure_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to EC1XGpibFigure (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
% display dialog box to verify user wants to exit gpib demo
selection = questdlg('Exit GPIB demo?', 'End GPIB demo','Yes','No','Yes');
switch selection,
   case 'Yes'
     AllTimers = timerfind;
     if ~isempty(AllTimers)
        stop (AllTimers); %stop and delete all timers
        delete (AllTimers);
        clear AllTimers;
    end
        
    AllInstruments = instrfind;
    if ~isempty(AllInstruments)
        fclose (AllInstruments);
        delete (AllInstruments); %stop and delete all gpib objects
        clear AllInstruments;
    end
    %delete figure
    delete(hObject);
    
   case 'No'
     return;
end


% --- Executes during object creation, after setting all properties.
function TempPlot_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TempPlot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate TempPlot


% --- Executes on button press in ChartButton.
function ChartButton_Callback(hObject, eventdata, handles)
% hObject    handle to ChartButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ChartButton


ChartButtonValue = get(hObject,'Value');
%if chart button pressed execute following if block
if ChartButtonValue
 
    % if a field has been created to store temperature in (strucChartdata)
    % then the axes has a plot currently displayed. Verify user wants to
    % clear this to start plotting new temp values to give user and
    % oppurtunity to save data
    if isfield(handles,'strucChartData')
        button = questdlg('Turning on chart will clear current chart figure',...
            'Activate chart','OK','Cancel','OK');
        
        % if user clicks cancel or closes dialog box turn button off and
        % exit callback
        if strcmp(button,'Cancel')
            set(hObject,'Value',0); 
            return;
         end
        if isempty(button)
        set(hObject,'Value',0);
            return;
        end
    end
     
    % if user clicks OK to dialog box, get value selected for period in pop
    % up menu
    switch get(handles.ChartPeriodPopupMenu,'Value')
        case 1
            PeriodSelected = 10;
        case 2
            PeriodSelected = 30;
        case 3
            PeriodSelected = 60;
        case 4
            PeriodSelected = 600;
        case 5
            PeriodSelected = 1800;
    end
    % set period of chart timer, disable other chart buttons and start chart timer           
    set (handles.ChartTempTimer,'period',PeriodSelected);
    start(handles.ChartTempTimer);
    set(hObject,'backgroundcolor','red');
    set(hObject,'string','Chart On');
    set(handles.SaveChartButton,'Enable','off');
    set(handles.OpenChartButton,'Enable','off');
    set(handles.PrintChartButton,'Enable','off');
    set(handles.ChartPeriodPopupMenu,'Enable','off');
    
else
    %if chart button clicked off, stop chart timer and enable other chart
    %buttons
    stop(handles.ChartTempTimer);
    set(hObject,'backgroundcolor','default');
    set(hObject,'string','Chart Off');
    set(handles.SaveChartButton,'Enable','on');
    set(handles.OpenChartButton,'Enable','on');
    set(handles.PrintChartButton,'Enable','on');
    set(handles.ChartPeriodPopupMenu,'Enable','on');
    % get chart timer object so that temperature and time data that was
    % stored in the timer's userdata field can be retrieved and stored into
    % the handles structure field 'strucChartData
    ChartTempTimer = handles.ChartTempTimer;
    handles.strucChartData = ChartTempTimer.UserData;
    %save new data added to handles structure
    guidata(hObject,handles);
end

% --------------------------------------------------------------------
function mnuFile_Callback(hObject, eventdata, handles)
% hObject    handle to mnuFile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function mnuFileChartSave_Callback(hObject, eventdata, handles)
% hObject    handle to mnuFileChartSave (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% --------------------------------------------------------------------
function mnuFileLoadChart_Callback(hObject, eventdata, handles)
% hObject    handle to mnuFileLoadChart (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function mnuFilePrintChart_Callback(hObject, eventdata, handles)
% hObject    handle to mnuFilePrintChart (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in SaveChartButton.
function SaveChartButton_Callback(hObject, eventdata, handles)
% hObject    handle to SaveChartButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% create a save file dialog box to store plotted chart data saved in the
% handles strucChartData field
[FileName,PathName] = uiputfile('ChartData.mat','Save Chart Data as...');
if FileName == 0
    return;
end
FileNameAndPathString = [PathName FileName];
% if handles structure has no strucChartData field or no data , then no plot exists on
% axes, so create error dialog box
if ~isfield(handles,'strucChartData')
    errordlg('No chart data to save','Save to file error');
    return;
end

if isempty(handles.strucChartData)
    errordlg('No chart data to save','Save to file error');
    return;
end
% saves the data in the strucChartData variable in the user specified
% filename and location
strucChartData = handles.strucChartData;
save(FileNameAndPathString,'strucChartData'); 

% --- Executes on button press in OpenChartButton.
function OpenChartButton_Callback(hObject, eventdata, handles)
% hObject    handle to OpenChartButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


%display the load file dialog box
[FileName,PathName] = uigetfile('*.mat','Load chart data');
if FileName == 0
    return;
end
FileNameAndPathString = [PathName FileName];
S = load (FileNameAndPathString); % load the data from file into the structure variable -S
if ~ isfield(S, 'strucChartData') % if strucChartData is not a valid field exit
    errordlg('Not a valid chart file','File Error');
     return;
end

% if the field TempData is not present in the strucChartData structure then
% file is not valid
strucChartData = S.strucChartData;
if ~isfield(strucChartData,'TempData')
    errordlg('Not a valid chart file','File Error');
    return;
end

% if no errors occured chart data was loaded successfully
handles.strucChartData = strucChartData;
guidata(hObject,handles);
set(handles.SaveChartButton,'enable','on'); %if Chart data is present then allow saving of this data
%extract temp and time data from strucChartData fields and plot onto axes
mtxTempData = strucChartData.TempData;
ElapsedTime = strucChartData.ElapsedTime;
TimeAndDateString = strucChartData.TimeAndDateString;
plot (ElapsedTime,mtxTempData);
MaxTempColumn = max(mtxTempData);
MaxTemp = max (MaxTempColumn)+5;
MinTempColumn = min(mtxTempData);
MinTemp = min (MinTempColumn)-5;
TimeMax = max(ElapsedTime)+1;
axis([0  TimeMax MinTemp MaxTemp]);
ylabel ('Temperature');
StartTimeString = ['Start: ' TimeAndDateString];
XlabelString = ['Time(min) ' StartTimeString];
xlabel (XlabelString);
legend('CH1','CH2','SET1');
title('PC1000 temp graph');

% --- Executes on button press in PrintChartButton.
function PrintChartButton_Callback(hObject, eventdata, handles)
% hObject    handle to PrintChartButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% if handles structure does not have a strucChartData field then axes has
% no plot - display error dialog
if ~isfield(handles,'strucChartData')
    errordlg('No chart to print','Print Error');
    return;
end
%Create a new figure to print, otherwise printing function will print
%figure with buttons and other objects
FigureToPrint = figure;
strucChartData = handles.strucChartData;
mtxTempData = strucChartData.TempData;
ElapsedTime = strucChartData.ElapsedTime;
TimeAndDateString = strucChartData.TimeAndDateString;
plot (ElapsedTime,mtxTempData);
MaxTempColumn = max(mtxTempData);
MaxTemp = max (MaxTempColumn)+5;
MinTempColumn = min(mtxTempData);
MinTemp = min (MinTempColumn)-5;
TimeMax = max(ElapsedTime)+1;
axis([0  TimeMax MinTemp MaxTemp]);
ylabel ('Temperature');
XlabelString = ['Time(min) ' TimeAndDateString];
xlabel (XlabelString);
legend('CH1','CH2','SET1');
title('PC1000 temp graph');
%print figure with temp plot and then delete
printdlg (FigureToPrint);
delete (FigureToPrint);

function TurnOffController (handles)

fprintf(handles.SunGpibObject,'OFF');
DisableGpibButtons(handles);
   
function DisableGpibButtons (handles)
% Disable buttons that would send controller commands if pressed 
% Disable text boxes as well
set(handles.SendButton,'Enable','off');
set(handles.StopButton,'Enable','off');
set(handles.ChartButton,'Enable','off');
set(handles.ChartButton,'backgroundcolor','default');
set(handles.ChartButton,'value',0);
set(handles.ChartButton,'string','Chart Off');
set(handles.CoolEnableButton,'Enable','off');
set(handles.CoolEnableButton,'backgroundcolor','default');
set(handles.HeatEnableButton,'Enable','off');
set(handles.HeatEnableButton,'backgroundcolor','default');
set(handles.PowerButton,'backgroundcolor','default');
set(handles.PowerButton,'string','OFF');
set(handles.CH1Temp,'Enable','off');
set(handles.CH2Temp,'Enable','off');
set(handles.SetTemp,'Enable','off');
set(handles.SaveChartButton,'Enable','on');
set(handles.OpenChartButton,'Enable','on');
set(handles.PrintChartButton,'Enable','on');
set(handles.RunPushButton,'Enable','off');
set(handles.StopLPbutton,'Enable','off');
set(handles.SetEdit,'Enable','off');
set(handles.RateEdit,'Enable','off');
set(handles.WaitEdit,'Enable','off');
set(handles.LPPopupMenu,'Enable','off');
set(handles.ChartPeriodPopupMenu,'Enable','off');
set(handles.ContinueLPButton,'Enable','off');
set(handles.PauseLPButton,'Enable','off');

% --- Executes during object creation, after setting all properties.
function GPIBAddPopMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to GPIBAddPopMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in GPIBAddPopMenu.
function GPIBAddPopMenu_Callback(hObject, eventdata, handles)
% hObject    handle to GPIBAddPopMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns GPIBAddPopMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from GPIBAddPopMenu

function ConnectError = ConnectToGpib (GpibAdd)
% Connect to a Sun controller through the GPIB bus
% !!Assume a NI board with a board index of 0 (default for most boards)!!
% Most of the code is error checking and notifying the user of
% what kind of error occurred
% To establish a connection create a gpib object% with the following command: 
% g = gpib(vendor,boardindex,primary address) ex: g = gpib ('ni',0,6) 
% creates a gpib object of a National Instrument card with a board index of 0 
% to communicate with a GPIB device with an address of 6.

% After the object is created establish a connection with the command fopen (g)
% Once the connection is made, commands may be sent to the GPIB device with
% fprintf(g, 'Command to send') and responses read with fscanf(g).
if nargin == 0
    GpibAdd = 6;
end

ConnectError = []; %Initialize variable to null - means connection not established
%Determine if the instrument toolbox is installed by getting GPIB drivers
GpibInfo = instrhwinfo ('gpib');
NumInsAdaptors = length (GpibInfo.InstalledAdaptors);
%If there are no drivers found display message and exit M-file
ErrMess = '';
if NumInsAdaptors == 0 
    
    ConnectError = 1;
else
    %!!!!assume board index is 0 otherwise un-comment following lines!!!
    %BoardIndex = input ('Enter a board index number (0 = default): ' );
    %if isempty(BoardIndex) 
        BoardIndex = 0;
        %end 
    % Select NI vendor
    % This M-file has only been tested with NI GPIB boards
    VendSelection = 'ni';
    % attempt to create GPIB object
    try
        % if there is no object with the primary address selected by
        % user that are open then create GPIB object 
        if isempty (instrfind('primaryaddress',GpibAdd,'status','open'));
            SunGPIB = gpib(VendSelection,BoardIndex,GpibAdd); %create object
            SunGPIB.timeout = 5;
        else
            % otherwise a connection already exists and no further action
            % necessary
            ConnectError = 0;
        end
        
    catch
        
        ConnectError = 2;
        
               
    end
    % if no error was generated trying to create GPIB object AND
    % if a connection does not exist yet, then attempt to connect else exit function
    if isempty (ErrMess) && isempty(ConnectError)
           
        %attempt to open or connect to GPIB board
        try
            fopen (SunGPIB);
            ConnectError = 0;
        %if unsuccesfull display error message and clear object created
        catch
            ConnectError = 3;
            fclose (SunGPIB);
            delete (SunGPIB);
            clear SunGPIB;
        end
    end
  
end


% --- Executes on button press in RunPushButton.
function RunPushButton_Callback(hObject, eventdata, handles)
% hObject    handle to RunPushButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% get  the value of the local program selected from the pop up menu and
% issue the run command to controller
LPNumber = get (handles.LPPopupMenu,'Value')-1;
LPNumber = num2str(LPNumber);
RunCommand = ['Run#',LPNumber];
fprintf(handles.SunGpibObject,RunCommand);


% --- Executes during object creation, after setting all properties.
function LPPopupMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LPPopupMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in LPPopupMenu.
function LPPopupMenu_Callback(hObject, eventdata, handles)
% hObject    handle to LPPopupMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns LPPopupMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from LPPopupMenu


% --- Executes on button press in StopLPbutton.


% --- Executes on button press in StopLPbutton.
function StopLPbutton_Callback(hObject, eventdata, handles)
% hObject    handle to StopLPbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%issue stop command to controller to stop local program 
fprintf(handles.SunGpibObject,'STOP');

function EnableGPIBButtons(handles)
%Enable text boxes and buttons on figure
set(handles.SetEdit,'Enable','on');
set(handles.RateEdit,'Enable','on');
set(handles.WaitEdit,'Enable','on');
set(handles.SendButton,'Enable','on');
set(handles.StopButton,'Enable','on');
set(handles.ChartButton,'Enable','on');
set(handles.OpenChartButton,'Enable','on');
set(handles.RunPushButton,'Enable','on');
set(handles.StopLPbutton,'Enable','on');
set(handles.LPPopupMenu,'Enable','on');
set(handles.PrintChartButton,'Enable','on');
set(handles.CoolEnableButton,'Enable','on');
set(handles.HeatEnableButton,'Enable','on');
set(handles.CH1Temp,'Enable','on');
set(handles.CH2Temp,'Enable','on');
set(handles.SetTemp,'Enable','on');
set(handles.ChartPeriodPopupMenu,'Enable','on');
set(handles.ContinueLPButton,'Enable','on');
set(handles.PauseLPButton,'Enable','on');

if isfield (handles,'strucChartData')
    
    if isempty(handles.strucChartData)
        set(handles.SaveChartButton,'Enable','off');
    else
        set(handles.SaveChartButton,'Enable','on');
        
    end
end


% --- Executes during object creation, after setting all properties.
function ChartPeriodPopupMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ChartPeriodPopupMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --- Executes on selection change in ChartPeriodPopupMenu.
function ChartPeriodPopupMenu_Callback(hObject, eventdata, handles)
% hObject    handle to ChartPeriodPopupMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns ChartPeriodPopupMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from ChartPeriodPopupMenu


% --- Executes on button press in PauseLPButton.
function PauseLPButton_Callback(hObject, eventdata, handles)
% hObject    handle to PauseLPButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
fprintf(handles.SunGpibObject,'BKPNT');

% --- Executes on button press in ContinueLPButton.
function ContinueLPButton_Callback(hObject, eventdata, handles)
% hObject    handle to ContinueLPButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
fprintf(handles.SunGpibObject,'BKPNTC');

